﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for GameMainWin.xaml
    /// </summary>
    public partial class GameMainWin : Window
    {
        int imageNum = 0;
        public GameMainWin()
        {
            InitializeComponent();
        }

        private void leftBtn_Click(object sender, RoutedEventArgs e)
        {
            imageNum--;
            if (imageNum == 0)
            {
                imageNum = 3;
            }

            string url = "pack://application:,,,/gameScene/" + imageNum + ".png";
            DoubleAnimation da = new DoubleAnimation();
            da.From = 0;    //起始值
            da.To = 1;      //结束值
            da.Duration = TimeSpan.FromSeconds(2);         //动画持续时间

            gameScene.Source = new BitmapImage(new Uri(url));
            this.gameScene.BeginAnimation(Image.OpacityProperty, da);

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            imageNum = 1;
            string url = "pack://application:,,,/gameScene/" + imageNum + ".png";


            DoubleAnimation da = new DoubleAnimation();
            da.From = 0;    //起始值
            da.To = 1;      //结束值
            da.Duration = TimeSpan.FromSeconds(2);         //动画持续时间

            gameScene.Source = new BitmapImage(new Uri(url));
            this.gameScene.BeginAnimation(Image.OpacityProperty, da);

            this.teamName.BeginAnimation(TextBlock.OpacityProperty, da);//开始动画



        }

        private void rightBtn_Click(object sender, RoutedEventArgs e)
        {
            imageNum++;
            if (imageNum == 4)
            {
                imageNum = 1;
            }
            string url = "pack://application:,,,/gameScene/" + imageNum + ".png";

            DoubleAnimation da = new DoubleAnimation();
            da.From = 0;    //起始值
            da.To = 1;      //结束值
            da.Duration = TimeSpan.FromSeconds(2);         //动画持续时间

            gameScene.Source = new BitmapImage(new Uri(url));
            this.gameScene.BeginAnimation(Image.OpacityProperty, da);
        }

        private void gameScene_MouseDown(object sender, MouseButtonEventArgs e)
        {
            // MessageBox.Show("当前图片为"+imageNum);
            MessageWin imageMsg = null;
            if (imageNum == 1)
            {
                imageMsg = new MessageWin("场景信息", "漫步于林海雪原，心情无比舒畅!");
            }
            else {
                imageMsg = new MessageWin("警告信息", "敬请等待该场景的提供!");
            }
            
            imageMsg.ShowDialog();
        }

        private void startBtn_Click(object sender, RoutedEventArgs e)
        {
            TakePhotoWin pWin = new TakePhotoWin();
            bool? value = pWin.ShowDialog();
            if (value == true)
            {
                StartWin startWin = new StartWin();
                startWin.ShowDialog();
            }
        }

        private void optionBtn_Click(object sender, RoutedEventArgs e)
        {
            OptionWin opWin = new OptionWin();
            opWin.ShowDialog();
        }

        private void quitBtn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        private void teamName_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            TeamWin teamWin = new TeamWin();
            teamWin.ShowDialog();
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
        }

        private void teamName_GotFocus(object sender, RoutedEventArgs e)
        {

        }
    }
}
