﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace MainForm
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    /// 
    public partial class MainWindow : Window
    {

        TcpClient client = null;
        NetworkStream stream = null;
        bool bConnected = false;
        public static int regSuccess = 0;
        private LoadingBar load = null;
       
        public MainWindow()
        {
            InitializeComponent();

            client = new TcpClient();
            try
            {
                client.Connect("127.0.0.1", 10000);
                stream = client.GetStream();
                bConnected = true;

                Thread thread = new Thread(new ThreadStart(run));
                thread.IsBackground = true;
                thread.Start();
            }
            catch
            {
                MessageBox.Show("客户端连接服务器失败!请您稍候重试!!");
            }
            
        }

        private void btn_register_Click(object sender, RoutedEventArgs e)
        {
            if (bConnected == true)
            {
                Register register = new Register(stream);
                register.ShowDialog();
            }
            else {
                MessageBox.Show("服务器连接失败，请稍候重试!!");
            }
        }

       
        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.DragMove();
        }

        public void CloseWindow(object sender, RoutedEventArgs args)
        {
            this.Close();
        }

        private void txt_userID_GotFocus(object sender, RoutedEventArgs e)
        {
            txt_userID_Copy.Text = "";
            txt_userID_Copy.Opacity = 0;
            txt_userID.Opacity = 100;
        }

        private void txt_passw_GotFocus(object sender, RoutedEventArgs e)
        {
            txt_passw_Copy.Text = "";
            txt_passw_Copy.Opacity = 0;
            txt_passw.Opacity = 100;
        }


        public void run()
        {
            try
            {
                while (bConnected)
                {
                    if (stream != null)
                    {
                        if (stream.CanRead)
                        {
                            byte[] myReadBuffer = new byte[1024];
                            string recieve = "";
                            int numberOfBytesRead = 0;

                            do
                            {
                                numberOfBytesRead = stream.Read(myReadBuffer, 0, myReadBuffer.Length);
                                recieve += Encoding.Unicode.GetString(myReadBuffer, 0, numberOfBytesRead);
                            }
                            while (stream.DataAvailable);

                            if (recieve == "OPENSUCCESS")
                            {
                                //MessageBox.Show(recieve);
                                this.Dispatcher.Invoke(new Action(() => {
                                    load.Close();
                                    this.Hide();
                                    GameMainWin gameWin = new GameMainWin();
                                    gameWin.ShowDialog();
                                }));

                            }
                            else if (recieve == "OPENFAILURE")
                            {
                                this.Dispatcher.Invoke(new Action(() =>
                                {
                                    load.Close();
                                    MessageBox.Show("你好，您输入的用户名或者是密码错误，请重新输入！");
                                }));
                                
                            }
                            else if (recieve == "REGISTERSUCCESS")
                            {
                                regSuccess = 1;
                            }
                            else if (recieve == "REGISTERFAILURE")
                            {
                                regSuccess = 2;
                            }

                        }
                    }
                }
            }
            catch { }
        }

        private void btn_login_Click(object sender, RoutedEventArgs e)
        {
            string UserName = txt_userID.Text;
            string userPass = txt_passw.Password;

            if (UserName == null || userPass == null)
            {
                MessageBox.Show("您的用户名或密码没有输入，请重新输入!");
                return;
            }

           

            string msg = UserName + "%%%%%" + userPass;
            byte[] bytes = Encoding.Unicode.GetBytes(msg);
            
            if(stream.CanWrite)
                stream.Write(bytes, 0, bytes.Length);

            load = new LoadingBar();
            load.ShowDialog();

        }
    }
     
}
