﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WPFMediaKit.DirectShow.Controls;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for PhotoTakeWin.xaml
    /// </summary>
    public partial class PhotoTakeWin : Window
    {
        //public string fileName = null;

       
        public PhotoTakeWin()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            if (MultimediaUtil.VideoInputNames.Length > 0)
            {
                vce.VideoCaptureSource = MultimediaUtil.VideoInputNames[0];  //选择那一台摄像头设备
            }
            else
            {
                MessageBox.Show("未检测到任何可用摄像头!");
            }
        }

        
        private void takeBtn_Click(object sender, RoutedEventArgs e)
        {
            if (takeBtn.Content == "拍照")
            {
                RenderTargetBitmap bmp = new RenderTargetBitmap((int)vce.ActualWidth, (int)vce.ActualHeight, 96, 96, PixelFormats.Default);
                bmp.Render(vce);
                BitmapEncoder encoder = new JpegBitmapEncoder();
                encoder.Frames.Add(BitmapFrame.Create(bmp));
                using (MemoryStream ms = new MemoryStream())
                {
                    encoder.Save(ms);
                    byte[] captureData = ms.ToArray();
                    Register.fileName = "photos\\" + DateTime.Now.ToString("yyyyMMddHHmmss") + ".jpg";
                    File.WriteAllBytes(Register.fileName, captureData);
                }

                string path = System.AppDomain.CurrentDomain.BaseDirectory + Register.fileName;

                FileStream fs = File.Open(path, FileMode.Open);
                //声明一个byte数组接受图片byte信息
                Register.fileBytes = new byte[fs.Length];

                using (fs)
                {
                    //将图片byte信息读入byte数组中
                    fs.Read(Register.fileBytes, 0, Register.fileBytes.Length);
                    fs.Close();
                }

                if (System.IO.File.Exists(path))
                {
                    imgShow.Source = new BitmapImage(new Uri(path, UriKind.Absolute));
                    //MessageBox.Show("照片保存!");
                    takeBtn.Content = "重拍";
                }
            }
            else {

                imgShow.Source = null;
                takeBtn.Content = "拍照";
                
            }
        }

        private void noBtn_Click(object sender, RoutedEventArgs e)
        {
            Register.fileName = null;
            this.DialogResult = false;
            this.Close();
            
        }

        private void yesBtn_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            this.Close();
        }


    }
}
