﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WPFMediaKit.DirectShow.Controls;
using System.Windows.Threading;
using System.Threading;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for TakePhotoWin.xaml
    /// </summary>
    /// 
    
    public partial class TakePhotoWin : Window
    {
        public TakePhotoWin()
        {
            InitializeComponent();

            Video.vce.BeginInit();
            Video.vce.Width = can.Width;
            Video.vce.Height = can.Height;
            Video.vce.Stretch = Stretch.Fill;
            //vce.LoadedBehavior = MediaState.Play;
            Video.vce.EndInit();
            can.Children.Add(Video.vce);

            Button btn = new Button
            {
                Name = "btn",
                Content = "点击拍照",
                Height = 27,
                Width = 80,
                HorizontalAlignment = HorizontalAlignment.Left,
                Margin = new Thickness(109, 232, 0, 0),
                VerticalAlignment = VerticalAlignment.Top,
                Visibility = Visibility.Visible
            };
            btn.Click += new RoutedEventHandler(Button_Click_1);
            can.Children.Add(btn);

            MessageBox.Show("请退出摄像头外围并点击拍照!");
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            if (MultimediaUtil.VideoInputNames.Length > 0)
            {
                Video.vce.VideoCaptureSource = MultimediaUtil.VideoInputNames[1];  //选择那一台摄像头设备
            }
            else
            {
                MessageBox.Show("未检测到任何可用摄像头!");
            }

        }

        private void takeWin_Closed(object sender, EventArgs e)
        {
            Video.vce.Stop();
            Video.vce.Close();
            Video.vce.VideoCaptureSource = null;
            grid.Children.Remove(Video.vce);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            RenderTargetBitmap bmp = new RenderTargetBitmap((int)Video.vce.ActualWidth, (int)Video.vce.ActualHeight, 96, 96, PixelFormats.Default);
            bmp.Render(Video.vce);
            Int32Rect a = new Int32Rect(0, 0, bmp.PixelWidth, bmp.PixelHeight);
            int stride = bmp.Format.BitsPerPixel * a.Width / 8;
            StartWin.data_f = new byte[a.Height * stride];

            bmp.CopyPixels(a, StartWin.data_f, stride, 0);

            StartWin.width = bmp.PixelWidth;
            StartWin.height = bmp.PixelHeight;

            this.DialogResult = true;

            Video.vce.Stop();
            Video.vce.Close();
            Video.vce.VideoCaptureSource = null;

            can.Children.Remove(Video.vce);
            this.Close();
        }


    }
}
