﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;
using System.Threading;
using System.Net.Sockets;
using System.IO;
using System.Data.SqlClient;

namespace Server
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 
    public partial class MainWindow : Window
    {
        TcpListener server = null;
        static TextBlock tempBlock = null;
        bool started = false;


        List<Client> clients = new List<Client>();

        public MainWindow()
        {
            InitializeComponent();
            tempBlock = myBlock;
        }


        public void threadMethod()
        {
            try
            {
                IPAddress ip = IPAddress.Parse("127.0.0.1");
                server = new TcpListener(ip, 10000);
                server.Start();
                setBlockText("服务器已经开启!\n等待客户端连接.......");
                started = true;
            }
            catch
            {
                MessageBox.Show("不能建立服务器!");
                return;
            }

            try
            {
                while (started)
                {
                    TcpClient s = server.AcceptTcpClient();

                    Client c = new Client(s);
                    setBlockText("一个客户端已经连接!");

                    Thread thread = new Thread(new ThreadStart(c.run));
                    thread.IsBackground = true;
                    thread.Start();

                    clients.Add(c);
                }
            }
            catch
            {
                // Console.WriteLine("不能接受信息!");
                setBlockText("不能接受信息!");
            }
        }

        private void openServerBtn_Click(object sender, RoutedEventArgs e)
        {
            Thread thread = new Thread(new ThreadStart(threadMethod));
            thread.IsBackground = true;
            thread.Start();
        }

        private void sendBtn_Click(object sender, RoutedEventArgs e)
        {
            foreach (Client c in clients)
            {
                c.send("感谢您登录我们的系统!");
            }
        }

        public void setBlockText(string str)
        {
            str += "\n";
            this.Dispatcher.Invoke(new Action(() => { myBlock.Text += str; }));
        }


        class Client
        {
            private TcpClient s;
            private NetworkStream stream = null;
            private bool bConnected = false;

            public Client(TcpClient s)
            {
                this.s = s;
                stream = s.GetStream();
                bConnected = true;
            }

            public void send(string str)
            {
                try
                {
                    if (stream.CanWrite)
                    {
                        byte[] bytes = Encoding.UTF8.GetBytes(str);
                        stream.Write(bytes, 0, bytes.Length);
                    }
                }
                catch
                {
                    MessageBox.Show("服务器发送消息失败!");
                }
            }

            public void run()
            {
                try
                {
                    while (bConnected)
                    {
                        if (stream != null)
                        {
                            if (stream.CanRead)
                            {
                                byte[] myReadBuffer = new byte[1024];
                                List<byte> list = new List<byte>();

                                string rec = "";
                                int numberOfBytesRead = 0;

                                do
                                {
                                    numberOfBytesRead = stream.Read(myReadBuffer, 0, myReadBuffer.Length);
                                    for (int i = 0; i < numberOfBytesRead; i++)
                                    {
                                        list.Add(myReadBuffer[i]);
                                    }
                                }
                                while (stream.DataAvailable);

                                byte[] tem = list.ToArray();

                                rec = Encoding.Unicode.GetString(tem);
                                Application.Current.Dispatcher.Invoke(new Action(() => { tempBlock.Text += rec; }));
                                Application.Current.Dispatcher.Invoke(new Action(() => { tempBlock.Text += "\n"; }));

                                //string[] str = rec.Split(new char[5] { '%', '%', '%','%','%' });
                                string[] str2;
                                rec = rec.Replace("%%%%%", "%");
                                str2 = rec.Split('%');

                                if (str2.Length == 8)
                                {


                                    using (SqlConnection conn = new SqlConnection("Data Source=.;Initial Catalog=MyProject;User ID=sa;Password=1234"))
                                    {
                                        conn.Open();

                                        using (SqlCommand cmd = conn.CreateCommand())
                                        {
                                            cmd.CommandText = "Select * from T_UserInfor where Name='" + str2[1] + "' OR Email='" + str2[6] + "'";
                                            Object obj = cmd.ExecuteScalar();
                                            if (obj != null)
                                            {
                                                if (stream.CanWrite)
                                                {
                                                    //MessageBox.Show("OPENSUCCESS");
                                                    byte[] bytes = Encoding.Unicode.GetBytes("REGISTERFAILURE");
                                                    //MessageBox.Show("OPENSUCCESSS");
                                                    stream.Write(bytes, 0, bytes.Length);
                                                }
                                            }
                                            else
                                            {
                                                string photo = str2[0];
                                                int m = Convert.ToInt32(photo);
                                                int mm = tem.Length;

                                                byte[] byPhoto = new byte[m];
                                                int pp = 0;
                                                for (int i = mm - m; i <= mm - 1; i++)
                                                {
                                                    byPhoto[pp] = tem[i];
                                                    pp++;
                                                }

                                                using (FileStream fs = new FileStream("F:\\photos\\" + str2[1] + ".jpg", FileMode.Create))
                                                {
                                                    fs.Write(byPhoto, 0, byPhoto.Length);
                                                }

                                                // using (SqlConnection conn1 = new SqlConnection("Data Source=.;Initial Catalog=MyProject;User ID=sa;Password=1234"))
                                                // {
                                                //  conn1.Open();

                                                string address = "I:\\photos" + str2[1] + ".jpg";
                                                //using (SqlCommand cmd = conn.CreateCommand())
                                                //{
                                                cmd.CommandText = "Insert into T_UserInfor(Name,Passwd,Sex,Birthday,Location,Email,PhotoAdd) values('" + str2[1] + "','" + str2[2] + "','" + str2[3] + "','" + str2[4] + "','" + str2[5] + "','" + str2[6] + "','" + address + "')";
                                                cmd.ExecuteNonQuery();
                                                // }


                                                if (stream.CanWrite)
                                                {
                                                    // MessageBox.Show("要发送咯!");
                                                    //MessageBox.Show("OPENSUCCESS");
                                                    byte[] bytes = Encoding.Unicode.GetBytes("REGISTERSUCCESS");
                                                    //MessageBox.Show("OPENSUCCESSS");
                                                    stream.Write(bytes, 0, bytes.Length);
                                                }
                                            }
                                        }
                                    }
                                }

                                else if (str2.Length == 2)
                                {
                                    using (SqlConnection conn = new SqlConnection("Data Source=.;Initial Catalog=MyProject;User ID=sa;Password=1234"))
                                    {
                                        conn.Open();

                                        using (SqlCommand cmd = conn.CreateCommand())
                                        {
                                            cmd.CommandText = "Select * from T_UserInfor where Name='" + str2[0] + "' AND Passwd='" + str2[1] + "'";
                                            Object obj = cmd.ExecuteScalar();
                                            if (obj != null)
                                            {
                                                if (stream.CanWrite)
                                                {
                                                    //MessageBox.Show("OPENSUCCESS");
                                                    byte[] bytes = Encoding.Unicode.GetBytes("OPENSUCCESS");
                                                    //MessageBox.Show("OPENSUCCESSS");
                                                    stream.Write(bytes, 0, bytes.Length);
                                                }
                                            }
                                            else
                                            {
                                                if (stream.CanWrite)
                                                {
                                                    //MessageBox.Show("OPENSUCCESS");
                                                    byte[] bytes = Encoding.Unicode.GetBytes("OPENFAILURE");
                                                    stream.Write(bytes, 0, bytes.Length);
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                catch { }
            }

        }
    }

}